/*
 * Interface wrapper code.
 *
 * Generated by SIP 6.8.5
 *
 *     Copyright: (c) 2020 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_aui.h"
        #include <wx/aui/auibar.h>
        #include <wx/gdicmn.h>
        #include <wx/bitmap.h>
        #include <wx/bmpbndl.h>
        #include <wx/sizer.h>
        #include <wx/window.h>


PyDoc_STRVAR(doc_wxAuiToolBarItem_Assign, "Assign(c)\n"
"\n"
"Assigns the properties of the wxAuiToolBarItem \"c\" to this.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_Assign(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_Assign(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem* c;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_c,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ9", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, sipType_wxAuiToolBarItem, &c))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->Assign(*c);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_Assign, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetWindow, "SetWindow(w)\n"
"\n"
"Assigns a window to the toolbar item.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetWindow(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetWindow(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        ::wxWindow* w;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_w,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ8", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, sipType_wxWindow, &w))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetWindow(w);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetWindow, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetWindow, "GetWindow() -> wx.Window\n"
"\n"
"Returns the wxWindow* associated to the toolbar item.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetWindow(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetWindow(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            ::wxWindow*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->GetWindow();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromType(sipRes, sipType_wxWindow, SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetWindow, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetId, "SetId(new_id)\n"
"\n"
"Sets the toolbar item identifier.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetId(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetId(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        int new_id;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_new_id,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bi", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, &new_id))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetId(new_id);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetId, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetId, "GetId() -> int\n"
"\n"
"Returns the toolbar item identifier.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetId(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetId(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            int sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->GetId();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return PyLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetId, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetKind, "SetKind(new_kind)\n"
"\n"
"Sets the wxAuiToolBarItem kind.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetKind(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetKind(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        int new_kind;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_new_kind,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bi", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, &new_kind))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetKind(new_kind);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetKind, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetKind, "GetKind() -> int\n"
"\n"
"Returns the toolbar item kind.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetKind(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetKind(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            int sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->GetKind();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return PyLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetKind, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetState, "SetState(new_state)\n"
"\n"
"Set the current state of the toolbar item.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetState(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetState(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        int new_state;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_new_state,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bi", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, &new_state))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetState(new_state);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetState, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetState, "GetState() -> int\n"
"\n"
"Gets the current state of the toolbar item.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetState(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetState(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            int sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->GetState();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return PyLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetState, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetSizerItem, "SetSizerItem(s)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetSizerItem(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetSizerItem(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        ::wxSizerItem* s;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_s,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ8", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, sipType_wxSizerItem, &s))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetSizerItem(s);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetSizerItem, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetSizerItem, "GetSizerItem() -> wx.SizerItem");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetSizerItem(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetSizerItem(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            ::wxSizerItem*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->GetSizerItem();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromType(sipRes, sipType_wxSizerItem, SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetSizerItem, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetLabel, "SetLabel(s)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetLabel(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetLabel(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxString* s;
        int sState = 0;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_s,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ1", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, sipType_wxString, &s, &sState))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetLabel(*s);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<::wxString *>(s), sipType_wxString, sState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetLabel, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetLabel, "GetLabel() -> String");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetLabel(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetLabel(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            ::wxString*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = new ::wxString(sipCpp->GetLabel());
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes, sipType_wxString, SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetLabel, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetBitmap, "SetBitmap(bmp)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetBitmap(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetBitmap(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxBitmapBundle* bmp;
        int bmpState = 0;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_bmp,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ1", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, sipType_wxBitmapBundle, &bmp, &bmpState))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetBitmap(*bmp);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<::wxBitmapBundle *>(bmp), sipType_wxBitmapBundle, bmpState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetBitmap, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetBitmap, "GetBitmap() -> wx.Bitmap");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetBitmap(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetBitmap(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            ::wxBitmap*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = new ::wxBitmap(sipCpp->GetBitmap());
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes, sipType_wxBitmap, SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetBitmap, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetDisabledBitmap, "SetDisabledBitmap(bmp)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetDisabledBitmap(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetDisabledBitmap(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxBitmapBundle* bmp;
        int bmpState = 0;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_bmp,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ1", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, sipType_wxBitmapBundle, &bmp, &bmpState))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetDisabledBitmap(*bmp);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<::wxBitmapBundle *>(bmp), sipType_wxBitmapBundle, bmpState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetDisabledBitmap, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetDisabledBitmap, "GetDisabledBitmap() -> wx.Bitmap");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetDisabledBitmap(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetDisabledBitmap(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            ::wxBitmap*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = new ::wxBitmap(sipCpp->GetDisabledBitmap());
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes, sipType_wxBitmap, SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetDisabledBitmap, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetHoverBitmap, "SetHoverBitmap(bmp)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetHoverBitmap(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetHoverBitmap(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxBitmapBundle* bmp;
        int bmpState = 0;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_bmp,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ1", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, sipType_wxBitmapBundle, &bmp, &bmpState))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetHoverBitmap(*bmp);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<::wxBitmapBundle *>(bmp), sipType_wxBitmapBundle, bmpState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetHoverBitmap, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetHoverBitmap, "GetHoverBitmap() -> wx.Bitmap");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetHoverBitmap(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetHoverBitmap(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            ::wxBitmap*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = new ::wxBitmap(sipCpp->GetHoverBitmap());
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes, sipType_wxBitmap, SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetHoverBitmap, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetShortHelp, "SetShortHelp(s)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetShortHelp(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetShortHelp(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxString* s;
        int sState = 0;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_s,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ1", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, sipType_wxString, &s, &sState))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetShortHelp(*s);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<::wxString *>(s), sipType_wxString, sState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetShortHelp, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetShortHelp, "GetShortHelp() -> String");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetShortHelp(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetShortHelp(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            ::wxString*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = new ::wxString(sipCpp->GetShortHelp());
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes, sipType_wxString, SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetShortHelp, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetLongHelp, "SetLongHelp(s)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetLongHelp(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetLongHelp(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxString* s;
        int sState = 0;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_s,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ1", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, sipType_wxString, &s, &sState))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetLongHelp(*s);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<::wxString *>(s), sipType_wxString, sState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetLongHelp, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetLongHelp, "GetLongHelp() -> String");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetLongHelp(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetLongHelp(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            ::wxString*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = new ::wxString(sipCpp->GetLongHelp());
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes, sipType_wxString, SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetLongHelp, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetMinSize, "SetMinSize(s)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetMinSize(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetMinSize(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxSize* s;
        int sState = 0;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_s,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ1", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, sipType_wxSize, &s, &sState))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetMinSize(*s);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast<::wxSize *>(s), sipType_wxSize, sState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetMinSize, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetMinSize, "GetMinSize() -> wx.Size");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetMinSize(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetMinSize(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            ::wxSize*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = new ::wxSize(sipCpp->GetMinSize());
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes, sipType_wxSize, SIP_NULLPTR);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetMinSize, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetSpacerPixels, "SetSpacerPixels(s)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetSpacerPixels(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetSpacerPixels(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        int s;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_s,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bi", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, &s))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetSpacerPixels(s);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetSpacerPixels, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetSpacerPixels, "GetSpacerPixels() -> int");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetSpacerPixels(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetSpacerPixels(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            int sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->GetSpacerPixels();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return PyLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetSpacerPixels, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetProportion, "SetProportion(p)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetProportion(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetProportion(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        int p;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_p,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bi", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, &p))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetProportion(p);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetProportion, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetProportion, "GetProportion() -> int");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetProportion(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetProportion(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            int sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->GetProportion();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return PyLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetProportion, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetActive, "SetActive(b)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetActive(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetActive(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        bool b;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_b,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bb", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, &b))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetActive(b);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetActive, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_IsActive, "IsActive() -> bool");

extern "C" {static PyObject *meth_wxAuiToolBarItem_IsActive(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_IsActive(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            bool sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->IsActive();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_IsActive, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetHasDropDown, "SetHasDropDown(b)\n"
"\n"
"Set whether this tool has a drop down button.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetHasDropDown(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetHasDropDown(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        bool b;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_b,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bb", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, &b))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetHasDropDown(b);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetHasDropDown, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_HasDropDown, "HasDropDown() -> bool\n"
"\n"
"Returns whether the toolbar item has an associated drop down button.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_HasDropDown(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_HasDropDown(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            bool sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->HasDropDown();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_HasDropDown, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetSticky, "SetSticky(b)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetSticky(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetSticky(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        bool b;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_b,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bb", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, &b))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetSticky(b);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetSticky, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_IsSticky, "IsSticky() -> bool");

extern "C" {static PyObject *meth_wxAuiToolBarItem_IsSticky(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_IsSticky(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            bool sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->IsSticky();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_IsSticky, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetUserData, "SetUserData(l)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetUserData(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetUserData(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        long l;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_l,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bl", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, &l))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetUserData(l);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetUserData, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetUserData, "GetUserData() -> long");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetUserData(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetUserData(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            long sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->GetUserData();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return PyLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetUserData, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_SetAlignment, "SetAlignment(l)");

extern "C" {static PyObject *meth_wxAuiToolBarItem_SetAlignment(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_SetAlignment(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        int l;
        ::wxAuiToolBarItem *sipCpp;

        static const char *sipKwdList[] = {
            sipName_l,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "Bi", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp, &l))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetAlignment(l);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_SetAlignment, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_GetAlignment, "GetAlignment() -> int");

extern "C" {static PyObject *meth_wxAuiToolBarItem_GetAlignment(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_GetAlignment(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            int sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->GetAlignment();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return PyLong_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_GetAlignment, SIP_NULLPTR);

    return SIP_NULLPTR;
}


PyDoc_STRVAR(doc_wxAuiToolBarItem_CanBeToggled, "CanBeToggled() -> bool\n"
"\n"
"Returns whether the toolbar item can be toggled.");

extern "C" {static PyObject *meth_wxAuiToolBarItem_CanBeToggled(PyObject *, PyObject *);}
static PyObject *meth_wxAuiToolBarItem_CanBeToggled(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxAuiToolBarItem *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAuiToolBarItem, &sipCpp))
        {
            bool sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->CanBeToggled();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    sipNoMethod(sipParseErr, sipName_AuiToolBarItem, sipName_CanBeToggled, SIP_NULLPTR);

    return SIP_NULLPTR;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxAuiToolBarItem(void *, int);}
static void release_wxAuiToolBarItem(void *sipCppV, int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast<::wxAuiToolBarItem *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void *array_wxAuiToolBarItem(Py_ssize_t);}
static void *array_wxAuiToolBarItem(Py_ssize_t sipNrElem)
{
    return new ::wxAuiToolBarItem[sipNrElem];
}


extern "C" {static void assign_wxAuiToolBarItem(void *, Py_ssize_t, void *);}
static void assign_wxAuiToolBarItem(void *sipDst, Py_ssize_t sipDstIdx, void *sipSrc)
{
    reinterpret_cast<::wxAuiToolBarItem *>(sipDst)[sipDstIdx] = *reinterpret_cast<::wxAuiToolBarItem *>(sipSrc);
}


extern "C" {static void *copy_wxAuiToolBarItem(const void *, Py_ssize_t);}
static void *copy_wxAuiToolBarItem(const void *sipSrc, Py_ssize_t sipSrcIdx)
{
    return new ::wxAuiToolBarItem(reinterpret_cast<const ::wxAuiToolBarItem *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_wxAuiToolBarItem(sipSimpleWrapper *);}
static void dealloc_wxAuiToolBarItem(sipSimpleWrapper *sipSelf)
{
    if (sipIsOwnedByPython(sipSelf))
    {
        release_wxAuiToolBarItem(sipGetAddress(sipSelf), 0);
    }
}


extern "C" {static void *init_type_wxAuiToolBarItem(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxAuiToolBarItem(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    ::wxAuiToolBarItem *sipCpp = SIP_NULLPTR;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, ""))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp = new ::wxAuiToolBarItem();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return SIP_NULLPTR;
            }

            return sipCpp;
        }
    }

    {
        const ::wxAuiToolBarItem* c;

        static const char *sipKwdList[] = {
            sipName_c,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J9", sipType_wxAuiToolBarItem, &c))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp = new ::wxAuiToolBarItem(*c);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return SIP_NULLPTR;
            }

            return sipCpp;
        }
    }

    return SIP_NULLPTR;
}


static PyMethodDef methods_wxAuiToolBarItem[] = {
    {sipName_Assign, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_Assign), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_Assign},
    {sipName_CanBeToggled, meth_wxAuiToolBarItem_CanBeToggled, METH_VARARGS, doc_wxAuiToolBarItem_CanBeToggled},
    {sipName_GetAlignment, meth_wxAuiToolBarItem_GetAlignment, METH_VARARGS, doc_wxAuiToolBarItem_GetAlignment},
    {sipName_GetBitmap, meth_wxAuiToolBarItem_GetBitmap, METH_VARARGS, doc_wxAuiToolBarItem_GetBitmap},
    {sipName_GetDisabledBitmap, meth_wxAuiToolBarItem_GetDisabledBitmap, METH_VARARGS, doc_wxAuiToolBarItem_GetDisabledBitmap},
    {sipName_GetHoverBitmap, meth_wxAuiToolBarItem_GetHoverBitmap, METH_VARARGS, doc_wxAuiToolBarItem_GetHoverBitmap},
    {sipName_GetId, meth_wxAuiToolBarItem_GetId, METH_VARARGS, doc_wxAuiToolBarItem_GetId},
    {sipName_GetKind, meth_wxAuiToolBarItem_GetKind, METH_VARARGS, doc_wxAuiToolBarItem_GetKind},
    {sipName_GetLabel, meth_wxAuiToolBarItem_GetLabel, METH_VARARGS, doc_wxAuiToolBarItem_GetLabel},
    {sipName_GetLongHelp, meth_wxAuiToolBarItem_GetLongHelp, METH_VARARGS, doc_wxAuiToolBarItem_GetLongHelp},
    {sipName_GetMinSize, meth_wxAuiToolBarItem_GetMinSize, METH_VARARGS, doc_wxAuiToolBarItem_GetMinSize},
    {sipName_GetProportion, meth_wxAuiToolBarItem_GetProportion, METH_VARARGS, doc_wxAuiToolBarItem_GetProportion},
    {sipName_GetShortHelp, meth_wxAuiToolBarItem_GetShortHelp, METH_VARARGS, doc_wxAuiToolBarItem_GetShortHelp},
    {sipName_GetSizerItem, meth_wxAuiToolBarItem_GetSizerItem, METH_VARARGS, doc_wxAuiToolBarItem_GetSizerItem},
    {sipName_GetSpacerPixels, meth_wxAuiToolBarItem_GetSpacerPixels, METH_VARARGS, doc_wxAuiToolBarItem_GetSpacerPixels},
    {sipName_GetState, meth_wxAuiToolBarItem_GetState, METH_VARARGS, doc_wxAuiToolBarItem_GetState},
    {sipName_GetUserData, meth_wxAuiToolBarItem_GetUserData, METH_VARARGS, doc_wxAuiToolBarItem_GetUserData},
    {sipName_GetWindow, meth_wxAuiToolBarItem_GetWindow, METH_VARARGS, doc_wxAuiToolBarItem_GetWindow},
    {sipName_HasDropDown, meth_wxAuiToolBarItem_HasDropDown, METH_VARARGS, doc_wxAuiToolBarItem_HasDropDown},
    {sipName_IsActive, meth_wxAuiToolBarItem_IsActive, METH_VARARGS, doc_wxAuiToolBarItem_IsActive},
    {sipName_IsSticky, meth_wxAuiToolBarItem_IsSticky, METH_VARARGS, doc_wxAuiToolBarItem_IsSticky},
    {sipName_SetActive, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetActive), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetActive},
    {sipName_SetAlignment, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetAlignment), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetAlignment},
    {sipName_SetBitmap, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetBitmap), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetBitmap},
    {sipName_SetDisabledBitmap, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetDisabledBitmap), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetDisabledBitmap},
    {sipName_SetHasDropDown, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetHasDropDown), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetHasDropDown},
    {sipName_SetHoverBitmap, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetHoverBitmap), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetHoverBitmap},
    {sipName_SetId, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetId), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetId},
    {sipName_SetKind, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetKind), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetKind},
    {sipName_SetLabel, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetLabel), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetLabel},
    {sipName_SetLongHelp, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetLongHelp), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetLongHelp},
    {sipName_SetMinSize, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetMinSize), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetMinSize},
    {sipName_SetProportion, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetProportion), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetProportion},
    {sipName_SetShortHelp, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetShortHelp), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetShortHelp},
    {sipName_SetSizerItem, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetSizerItem), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetSizerItem},
    {sipName_SetSpacerPixels, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetSpacerPixels), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetSpacerPixels},
    {sipName_SetState, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetState), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetState},
    {sipName_SetSticky, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetSticky), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetSticky},
    {sipName_SetUserData, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetUserData), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetUserData},
    {sipName_SetWindow, SIP_MLMETH_CAST(meth_wxAuiToolBarItem_SetWindow), METH_VARARGS|METH_KEYWORDS, doc_wxAuiToolBarItem_SetWindow}
};

sipVariableDef variables_wxAuiToolBarItem[] = {
    {PropertyVariable, sipName_Window, &methods_wxAuiToolBarItem[17], &methods_wxAuiToolBarItem[39], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_UserData, &methods_wxAuiToolBarItem[16], &methods_wxAuiToolBarItem[38], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_State, &methods_wxAuiToolBarItem[15], &methods_wxAuiToolBarItem[36], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_SpacerPixels, &methods_wxAuiToolBarItem[14], &methods_wxAuiToolBarItem[35], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_SizerItem, &methods_wxAuiToolBarItem[13], &methods_wxAuiToolBarItem[34], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_ShortHelp, &methods_wxAuiToolBarItem[12], &methods_wxAuiToolBarItem[33], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_Proportion, &methods_wxAuiToolBarItem[11], &methods_wxAuiToolBarItem[32], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_MinSize, &methods_wxAuiToolBarItem[10], &methods_wxAuiToolBarItem[31], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_LongHelp, &methods_wxAuiToolBarItem[9], &methods_wxAuiToolBarItem[30], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_Label, &methods_wxAuiToolBarItem[8], &methods_wxAuiToolBarItem[29], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_Kind, &methods_wxAuiToolBarItem[7], &methods_wxAuiToolBarItem[28], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_Id, &methods_wxAuiToolBarItem[6], &methods_wxAuiToolBarItem[27], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_HoverBitmap, &methods_wxAuiToolBarItem[5], &methods_wxAuiToolBarItem[26], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_DisabledBitmap, &methods_wxAuiToolBarItem[4], &methods_wxAuiToolBarItem[24], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_Bitmap, &methods_wxAuiToolBarItem[3], &methods_wxAuiToolBarItem[23], SIP_NULLPTR, SIP_NULLPTR},
    {PropertyVariable, sipName_Alignment, &methods_wxAuiToolBarItem[2], &methods_wxAuiToolBarItem[22], SIP_NULLPTR, SIP_NULLPTR},
};

PyDoc_STRVAR(doc_wxAuiToolBarItem, "AuiToolBarItem()\n"
"AuiToolBarItem(c)\n"
"\n"
"wxAuiToolBarItem is part of the wxAUI class framework, representing a\n"
"toolbar element.");


sipClassTypeDef sipTypeDef__aui_wxAuiToolBarItem = {
    {
        -1,
        SIP_NULLPTR,
        SIP_NULLPTR,
        SIP_TYPE_CLASS,
        sipNameNr_wxAuiToolBarItem,
        SIP_NULLPTR,
        SIP_NULLPTR,
    },
    {
        sipNameNr_AuiToolBarItem,
        {0, 0, 1},
        40, methods_wxAuiToolBarItem,
        0, SIP_NULLPTR,
        16, variables_wxAuiToolBarItem,
        {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},
    },
    doc_wxAuiToolBarItem,
    -1,
    -1,
    SIP_NULLPTR,
    SIP_NULLPTR,
    init_type_wxAuiToolBarItem,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    dealloc_wxAuiToolBarItem,
    assign_wxAuiToolBarItem,
    array_wxAuiToolBarItem,
    copy_wxAuiToolBarItem,
    release_wxAuiToolBarItem,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
};
